/*
 * R : gȐ\NX
 *
 * Copyright 2000 by Information-technology Promotion Agency, Japan
 * Copyright 2000 by Precision Modeling Laboratory, Inc., Tokyo, Japan
 * Copyright 2000 by Software Research Associates, Inc., Tokyo, Japan
 *
 * $Id: JgclTrimmedCurve3D.java,v 1.71 2000/08/11 06:19:03 shikano Exp $
 */

package jp.go.ipa.jgcl;

import java.util.Vector;
import java.io.OutputStream;
import java.io.PrintWriter;

/**
 * R : gȐ\NXB
 * <p>
 * gȐ́AȐ̈ꕔLƂLȐłB
 * ꕔLƂ邱Ƃg~OA
 * LƂԂ̂Ƃg~OԂƂB
 * </p>
 * <p>
 * ̃NX̃CX^X́A
 * <ul>
 * <li> g~ȎΏۂƂȂȐ basisCurve
 * <li> g~OԂ̎n_Ȑ̃p[^l tParam1 邢͍Wl tPnt1
 * <li> g~OԂ̏I_Ȑ̃p[^l tParam2 邢͍Wl tPnt2
 * <li> g~OԂ̎n_Ƃ tParam1  tPnt1 ̂ǂD悷邩 masterRepresentation1
 * <li> g~OԂ̏I_Ƃ tParam2  tPnt2 ̂ǂD悷邩 masterRepresentation2
 * <li>	gȐȐƓۂtO senseAgreement
 * </ul>
 * ێB
 * </p>
 * <p>
 * gȐ̂̂̒`͗LŔIȂ̂łA
 * p[^Ԃ [0, |tParam2 - tParam1|] ƂB
 * </p>
 * <p>
 * <a name="CONSTRAINTS">[Ԃ̍S]</a>
 * </p>
 * <p>
 * tPnt1  null ł\ȂȀꍇɂ
 * masterRepresentation1 ̒l
 * JgclTrimmingPreference.PARAMETER łȂ΂ȂȂB
 * </p>
 * <p>
 * l
 * tPnt2  null ł\ȂȀꍇɂ
 * masterRepresentation2 ̒l
 * JgclTrimmingPreference.PARAMETER łȂ΂ȂȂB
 * </p>
 * <p>
 * tParam1, tParam2 
 * basisCurve ̃p[^`Ɏ܂ĂȂ΂ȂȂB
 * </p>
 * <p>
 * ȐIłꍇA
 * senseAgreement  true  ł (tParam1 &lt; tParam2)
 * senseAgreement  false ł (tParam1 &gt; tParam2)
 * łȂ΂ȂȂB
 * </p>
 * <p>
 * ȐIłꍇA
 * senseAgreement  true  ł
 * tParam2 ̒l (tParam1 &lt; tParam2) 𖞂悤
 * ̃CX^X̓ŎIɏCB
 * l
 * senseAgreement  false ł
 * tParam1 ̒l (tParam1 &gt; tParam2) 𖞂悤
 * ̃CX^X̓ŎIɏCB
 * </p>
 *
 * @version $Revision: 1.71 $, $Date: 2000/08/11 06:19:03 $
 * @author Information-technology Promotion Agency, Japan
 */

public class JgclTrimmedCurve3D extends JgclBoundedCurve3D {

    /**
     * ȐB
     * @serial
     */
    private JgclParametricCurve3D basisCurve;

    /**
     * g~OԂ̎n_WlB
     * <p>
     * KvɉăLbVB
     * </p>
     * @serial
     */
    private JgclPoint3D tPnt1;

    /**
     * g~OԂ̏I_WlB
     * <p>
     * KvɉăLbVB
     * </p>
     * @serial
     */
    private JgclPoint3D tPnt2;

    /**
     * g~OԂ̎n_Ȑ̃p[^lB
     * @serial
     */
    private double tParam1;

    /**
     * g~OԂ̏I_Ȑ̃p[^lB
     * @serial
     */
    private double tParam2;

    /**
     * g~OԂ̎n_Ƃ tParam1  tPnt1 ̂ǂD悷邩B
     * @serial
     * @see	JgclTrimmingPreference
     */
    private int masterRepresentation1;

    /**
     * g~OԂ̏I_Ƃ tParam2  tPnt2 ̂ǂD悷邩B
     * @serial
     * @see	JgclTrimmingPreference
     */
    private int masterRepresentation2;

    /**
     * gȐȐƓۂtOB
     * @serial
     */
    private boolean senseAgreement;

    /**
     * ^ꂽp[^lA
     * ̃gȐ̕Ȑ̃p[^`͈͓̔ɂ邩ۂ𒲂ׂB
     * <p>
     * param AȐ̃p[^`OĂꍇɂ
     * JgclParameterOutOfRange ̗O𔭐B
     * </p>
     *
     * @param param	Ȑɑ΂p[^l
     * @return 	KvɉāA܂񂾃p[^l
     * @see	JgclParametricCurve#checkValidity(double)
     * @see	JgclParameterDomain#wrap(double)
     * @see	JgclParameterOutOfRange
     */
    private double checkParamValidity(double param)
    {
	if (basisCurve.isPeriodic()) {
	    JgclParameterDomain domain = basisCurve.parameterDomain();
	    return domain.wrap(param);
	}
	basisCurve.checkValidity(param);
	return param;
    }

    /**
     * ^ꂽWl (̃gȐ̕Ȑɑ΂) p[^l̊Ԃ
     * 邩ۂ𒲂ׂB
     * <p>
     * pnt  param ̊ԂɐȂꍇɂ́A
     * JgclInvalidArgumentValue ̗O𔭐B
     * </p>
     * <p>
     * pnt  null ł΁Ã\bh͉ȂB
     * </p>
     *
     * @param pnt	Wl
     * @param param	Ȑɑ΂p[^l
     * @see	JgclInvalidArgumentValue
     */
    private void checkPointValidity(JgclPoint3D pnt, double param)
    {
	if (pnt != null) {
	    if (!basisCurve.coordinates(param).identical(pnt))
		throw new JgclInvalidArgumentValue();
	}
    }

    /**
     * etB[hɒlݒ肷B
     * <p>
     * ̒l <a href="#CONSTRAINTS">[Ԃ̍S]</a> 𖞂Ȃꍇɂ́A
     * JgclParameterOutOfRange  JgclInvalidArgumentValue ̗O𔭐B
     * </p>
     *
     * @param basicCurve	Ȑ
     * @param tPnt1	g~OԂ̎n_Wl
     * @param tPnt2	g~OԂ̏I_Wl
     * @param tParam1	g~OԂ̎n_p[^l
     * @param tParam2	g~OԂ̏I_p[^l
     * @param masterRepresentation1	tPnt1  tParam1 ̂ǂD悷邩l
     * @param masterRepresentation2	tPnt2  tParam2 ̂ǂD悷邩l
     * @param senseAgreement	gȐȐƓۂtO
     * @see	JgclTrimmingPreference
     * @see	JgclParameterOutOfRange
     * @see	JgclInvalidArgumentValue
     */
    private void setParams(JgclParametricCurve3D basisCurve,
			   JgclPoint3D tPnt1, JgclPoint3D tPnt2,
			   double tParam1, double tParam2,
			   int masterRepresentation1,
			   int masterRepresentation2,
			   boolean senseAgreement)
    {
	this.basisCurve = basisCurve;
	tParam1 = checkParamValidity(tParam1); this.tParam1 = tParam1;
	tParam2 = checkParamValidity(tParam2); this.tParam2 = tParam2;
	JgclConditionOfOperation condition =
	    JgclConditionOfOperation.getCondition();
	double pTol = condition.getToleranceForParameter();

	if (Math.abs(tParam2 - tParam1) < pTol)
	    throw new JgclInvalidArgumentValue();

	checkPointValidity(tPnt1, tParam1); this.tPnt1 = tPnt1;
	checkPointValidity(tPnt2, tParam2); this.tPnt2 = tPnt2;
	this.masterRepresentation1 = masterRepresentation1;
	this.masterRepresentation2 = masterRepresentation2;

	if (basisCurve.isPeriodic()) {
	    JgclParameterSection sec = basisCurve.parameterDomain().section();
	    if (senseAgreement) {
		if (tParam1 > tParam2)
		    this.tParam2 = tParam2 += sec.increase();
	    }
	    else {
		if (tParam1 < tParam2)
		    this.tParam1 = tParam1 += sec.increase();
	    }
	}
	else {
	    if (senseAgreement) {
		if (tParam1 > tParam2)
		    throw new JgclInvalidArgumentValue();
	    }
	    else {
		if (tParam1 < tParam2)
		    throw new JgclInvalidArgumentValue();
	    }
	}
	// now always senseAgreement == (tParam1 < tParam2)

	this.senseAgreement = senseAgreement;
    }

    /**
     * etB[hɐݒ肷l̂̂^ăIuWFNg\zB
     * <p>
     * ̒l <a href="#CONSTRAINTS">[Ԃ̍S]</a> 𖞂Ȃꍇɂ́A
     * JgclParameterOutOfRange  JgclInvalidArgumentValue ̗O𔭐B
     * </p>
     *
     * @param basicCurve	Ȑ
     * @param tPnt1	g~OԂ̎n_Wl
     * @param tPnt2	g~OԂ̏I_Wl
     * @param tParam1	g~OԂ̎n_p[^l
     * @param tParam2	g~OԂ̏I_p[^l
     * @param masterRepresentation1	tPnt1  tParam1 ̂ǂD悷邩l
     * @param masterRepresentation2	tPnt2  tParam2 ̂ǂD悷邩l
     * @param senseAgreement	gȐȐƓۂtO
     * @see	JgclTrimmingPreference
     * @see	JgclParameterOutOfRange
     * @see	JgclInvalidArgumentValue
     */
    JgclTrimmedCurve3D(JgclParametricCurve3D basisCurve,
		       JgclPoint3D tPnt1, JgclPoint3D tPnt2,
		       double tParam1, double tParam2,
		       int masterRepresentation1,
		       int masterRepresentation2,
		       boolean senseAgreement)
    {
	super();
	setParams(basisCurve, tPnt1, tPnt2, tParam1, tParam2,
		  masterRepresentation1, masterRepresentation2,
		  senseAgreement);
    }

    /**
     * Ȑƃg~OԂ̗[_Wl^ăIuWFNg\zB
     * <p>
     * ̃RXgN^̓ł́A
     * tPnt1, tPnt2 ɑΉȐ̃p[^l tParam1, tParam2 
     * ߂B̏Ɏs (܂A^ꂽWlȐɂȂ) ꍇɂ
     * JgclInvalidArgumentValue ̗O𔭐B
     * </p>
     * <p>
     * masterRepresentation1, masterRepresentation2 ̒l͂Ƃ
     * JgclTrimmingPreference.POINT ƂB
     * </p>
     * <p>
     * ̂悤ɗpӂl <a href="#CONSTRAINTS">[Ԃ̍S]</a> 𖞂Ȃꍇɂ́A
     * JgclParameterOutOfRange  JgclInvalidArgumentValue ̗O𔭐B
     * </p>
     * 
     * @param basicCurve	Ȑ
     * @param tPnt1	g~OԂ̎n_̍Wl
     * @param tPnt2	g~OԂ̏I_̍Wl
     * @param senseAgreement	gȐȐƓۂtO
     * @see	JgclTrimmingPreference
     * @see	JgclParameterOutOfRange
     * @see	JgclInvalidArgumentValue
     * @see	JgclParametricCurve3D#pointToParameter(JgclPoint3D)
     */
    public JgclTrimmedCurve3D(JgclParametricCurve3D basisCurve,
			      JgclPoint3D tPnt1, JgclPoint3D tPnt2,
			      boolean senseAgreement) {
	super();
	setParams(basisCurve, tPnt1, tPnt2,
		  basisCurve.pointToParameter(tPnt1),
		  basisCurve.pointToParameter(tPnt2),
		  JgclTrimmingPreference.POINT,
		  JgclTrimmingPreference.POINT,
		  senseAgreement);
    }

    /**
     * Ȑƃg~OԂ̗[_̕Ȑł̃p[^l^ăIuWFNg\zB
     * <p>
     * ̃RXgN^̓ł́A
     * tParam1, tParam ɑΉȐ̍Wl tPnt1, tPnt2 
     * ߂B̏Ɏs (܂A^ꂽp[^l
     * Ȑ̃p[^`OĂ) ꍇɂ
     * JgclParameterOutOfRange ̗O𔭐B
     * </p>
     * <p>
     * masterRepresentation1, masterRepresentation2 ̒l͂Ƃ
     * JgclTrimmingPreference.PARAMETER ƂB
     * </p>
     * <p>
     * ̂悤ɗpӂl <a href="#CONSTRAINTS">[Ԃ̍S]</a> 𖞂Ȃꍇɂ́A
     * JgclParameterOutOfRange  JgclInvalidArgumentValue ̗O𔭐B
     * </p>
     * 
     * @param basicCurve	Ȑ
     * @param tParam1	g~OԂ̎n_\p[^l
     * @param tParam2	g~OԂ̏I_\p[^l
     * @param senseAgreement	gȐȐƓۂtO
     * @see	JgclParametricCurve3D#coordinates(double)
     * @see	JgclTrimmingPreference
     * @see	JgclParameterOutOfRange
     * @see	JgclInvalidArgumentValue
     */
    public JgclTrimmedCurve3D(JgclParametricCurve3D basisCurve,
			      double tParam1, double tParam2,
			      boolean senseAgreement)
    {
	super();
	setParams(basisCurve, null, null, tParam1, tParam2,
		  JgclTrimmingPreference.PARAMETER,
		  JgclTrimmingPreference.PARAMETER,
		  senseAgreement);
    }

    /**
     * Ȑƃg~OԂ\p[^ԗ^ăIuWFNg\zB
     * <p>
     * pint ̊Jnl tParam1AIl tParam2 ƂB
     * ܂ pint ̑lł senseAgreement  trueA
     * łȂ senseAgreement  false ƂB
     * </p>
     * <p>
     * tPnt1, tPnt2 ̒l͂Ƃ null ƂB
     * </p>
     * <p>
     * masterRepresentation1, masterRepresentation2 ̒l͂Ƃ
     * JgclTrimmingPreference.PARAMETER ƂB
     * </p>
     * <p>
     * ̂悤ɗpӂl <a href="#CONSTRAINTS">[Ԃ̍S]</a> 𖞂Ȃꍇɂ́A
     * JgclParameterOutOfRange  JgclInvalidArgumentValue ̗O𔭐B
     * </p>
     * 
     * @param basicCurve	Ȑ
     * @param pint	g~OԂ\p[^
     * @see	JgclTrimmingPreference
     * @see	JgclParameterOutOfRange
     * @see	JgclInvalidArgumentValue
     */
    public JgclTrimmedCurve3D(JgclParametricCurve3D basisCurve,
			      JgclParameterSection pint)
    {
	super();
	setParams(basisCurve, null, null, pint.start(), pint.end(),
		  JgclTrimmingPreference.PARAMETER,
		  JgclTrimmingPreference.PARAMETER,
		  pint.increase() > 0);
    }

    /**
     * ̃gȐ̕ȐԂB
     * 
     * @return	Ȑ
     */
    public JgclParametricCurve3D basisCurve() {
	return this.basisCurve;
    }

    /**
     * ̃gȐ̃g~OԂ̎n_WlԂB
     * <p>
     * LbVs킸Aݒl̂܂ܕԂB
     * </p>
     * 
     * @return	g~OԂ̎n_̍Wl
     */
    public JgclPoint3D tPnt1() {
	return this.tPnt1;
    }

    /**
     * ̃gȐ̃g~OԂ̏I_WlԂB
     * <p>
     * LbVs킸Aݒl̂܂ܕԂB
     * </p>
     * 
     * @return	g~OԂ̏I_̍Wl
     */
    public JgclPoint3D tPnt2() {
	return this.tPnt2;
    }

    /**
     * ̃gȐ̃g~OԂ̎n_Ȑ̃p[^lԂB
     * 
     * @return	g~OԂ̎n_Ȑ̃p[^l
     */
    public double tParam1() {
	return this.tParam1;
    }

    /**
     * ̃gȐ̃g~OԂ̏I_Ȑ̃p[^lԂB
     * 
     * @return	g~OԂ̏I_Ȑ̃p[^l
     */
    public double tParam2() {
	return this.tParam2;
    }

    /**
     * ̃gȐ masterRepresentation1 ԂB
     * 
     * @return	masterRepresentation1 ̒l
     * @see	JgclTrimmingPreference
     */
    public int masterRepresentation1() {
	return this.masterRepresentation1;
    }

    /**
     * ̃gȐ masterRepresentation2 ԂB
     * 
     * @return	masterRepresentation2 ̒l
     * @see	JgclTrimmingPreference
     */
    public int masterRepresentation2() {
	return this.masterRepresentation2;
    }

    /**
     * ̃gȐ senseAgreement ԂB
     * 
     * @return	gȐȐƓȂ trueAȂ false
     */
    public boolean senseAgreement() {
	return this.senseAgreement;
    }

    /**
     * ̃gȐɑ΂ė^ꂽp[^lA
     * Ȑɑ΂p[^lɕϊB
     * <p>
     * ^ꂽp[^l̋Ȑ̒`OĂꍇɂ
     * JgclParameterOutOfRange ̗O𔭐B
     * </p>
     * 
     * @param param	gȐɑ΂p[^l
     * @return	Ȑɑ΂p[^l
     */
    public double toBasisParameter(double param) {
	checkValidity(param);
	if (senseAgreement) {
	    // s = t - t1, i.e. t = s + t1
	    return param + tParam1;
	}
	else {
	    // s = t1 - t, i.e. t = t1 - s
	    return tParam1 - param;
	}
    }

    /**
     * ̃gȐɑ΂ė^ꂽp[^ԂA
     * Ȑɑ΂p[^ԂɕϊB
     * <p>
     * ^ꂽp[^Ԃ̋Ȑ̒`OĂꍇɂ
     * JgclParameterOutOfRange ̗O𔭐B
     * </p>
     * 
     * @param param	gȐɑ΂p[^
     * @return	Ȑɑ΂p[^
     */
    public JgclParameterSection toBasisParameter(JgclParameterSection pint) {
	double start = toBasisParameter(pint.start());
	double end = toBasisParameter(pint.end());

	return new JgclParameterSection(start, end - start);
    }

    /**
     * ̃gȐ̕Ȑɑ΂ė^ꂽp[^lA
     * ̃gȐɑ΂p[^lɕϊB
     * 
     * @param param	Ȑɑ΂p[^l
     * @return	gȐɑ΂p[^l
     */
    public double toOwnParameter(double param) {
	if (basisCurve.isPeriodic()) {
	    double absInc = basisCurve.parameterDomain().section().absIncrease();
	    if (senseAgreement == true) {
		while (param < tParam1)
		    param += absInc;
		while (tParam2 < param)
		    param -= absInc;
		if (param < tParam1) {
		    if ((tParam1 - param) > ((param + absInc) - tParam2))
			param += absInc;
		}
	    } else {
		while (param < tParam2)
		    param += absInc;
		while (tParam1 < param)
		    param -= absInc;
		if (param < tParam2) {
		    if ((tParam2 - param) > ((param + absInc) - tParam1))
			param += absInc;
		}
	    }
	}

	return (senseAgreement) ? (param - tParam1) : (tParam1 - param);
    }

    /**
     * ^ꂽp[^Ԃɂ邱̋Ȑ̎ԏł̒ (̂) ԂB
     * <p>
     * pint ̑l͕ł܂ȂB
     * </p>
     * <p>
     * ^ꂽp[^Ԃ̋Ȑ̒`OĂꍇɂ
     * JgclParameterOutOfRange ̗O𔭐B
     * </p>
     * 
     * @param pint	Ȑ̒߂p[^
     * @return	w肳ꂽp[^ԂɂȐ̒
     * @see	JgclParameterOutOfRange
     */
    public double length(JgclParameterSection pint)
    {
        return basisCurve.length(toBasisParameter(pint));
    }

    /**
     * ̋Ȑ́A^ꂽp[^lł̍WlԂB
     * <p>
     * ^ꂽp[^l`OĂꍇɂ́A
     * JgclParameterOutOfRange ̗O𔭐B
     * </p>
     * 
     * @param param	p[^l
     * @return		Wl
     * @see	JgclParameterOutOfRange
     */
    public JgclPoint3D coordinates(double param)
    {
	return basisCurve.coordinates(toBasisParameter(param));
    }

    /**
     * ̋Ȑ́A^ꂽp[^lł̐ڃxNgԂB
     * <p>
     * ^ꂽp[^l`OĂꍇɂ́A
     * JgclParameterOutOfRange ̗O𔭐B
     * </p>
     * 
     * @param param	p[^l
     * @return		ڃxNg
     * @see	JgclParameterOutOfRange
     */
    public JgclVector3D tangentVector(double param) 
    {
	JgclVector3D tang = basisCurve.tangentVector(toBasisParameter(param));

	if (senseAgreement)
	    return tang;
	else
	    return tang.multiply(-1);
    }

    /**
     * ̋Ȑ́A^ꂽp[^lł̋ȗԂB
     * <p>
     * ^ꂽp[^l`OĂꍇɂ́A
     * JgclParameterOutOfRange ̗O𔭐B
     * </p>
     * 
     * @param param	p[^l
     * @return		ȗ
     * @see	JgclParameterOutOfRange
     */
    public JgclCurveCurvature3D curvature(double param)
    {
	return basisCurve.curvature(toBasisParameter(param));
    }

    /**
     * ̋Ȑ́A^ꂽp[^lł̃CԂB
     * <p>
     * ^ꂽp[^l`OĂꍇɂ́A
     * JgclParameterOutOfRange ̗O𔭐B
     * </p>
     * 
     * @param param	p[^l
     * @return		C
     * @see	JgclParameterOutOfRange
     */
    public double torsion(double param)
    {
	return basisCurve.torsion(toBasisParameter(param));
    }

    /**
     * ̋Ȑ́A^ꂽp[^lł̓֐ԂB
     * <p>
     * ^ꂽp[^l`OĂꍇɂ́A
     * JgclParameterOutOfRange ̗O𔭐B
     * </p>
     * 
     * @param param	p[^l
     * @return		֐
     * @see	JgclParameterOutOfRange
     */
    public JgclCurveDerivative3D evaluation(double param)
    {
	JgclCurveDerivative3D curv = 
	    basisCurve.evaluation(toBasisParameter(param));
	if (senseAgreement)
	    return curv;
	else {
	    JgclCurveDerivative3D rcurv =
		new JgclCurveDerivative3D(curv.d0D(), curv.d1D().multiply(-1), 
					  curv.d2D(), curv.d3D().multiply(-1));
	    return rcurv;
	}
    }

    /**
     * 炩̉Zɂēꂽp[^lA
     * ̋Ȑ̒`ɋIɎ߂B
     * <p>
     * l`悩OꂷĂāA
     * IɎ߂邱ƂKłȂꍇɂ́ADouble.NaN ԂB
     * </p>
     *
     * @param param	炩̉Zɂēꂽp[^l
     * @return	`Ɏ߂p[^l
     * @see	JgclParametricCurve3D#parameterValidity(double)
     */
    private double forceComputedParameter(double param) {
	switch(parameterValidity(param)) {
	case JgclParameterValidity.OUTSIDE:
	    param = Double.NaN;
	    break;

	case JgclParameterValidity.TOLERATED_LOWER_LIMIT:
	    param = parameterDomain().section().lower();
	    break;

	case JgclParameterValidity.TOLERATED_UPPER_LIMIT:
	    param = parameterDomain().section().upper();
	    break;

	default:
	    break;
	}

	return param;
    }

    /**
     * ̋Ȑ̓ٓ_ԂB
     * <p>
     * ٓ_݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @return	ٓ_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    public JgclPointOnCurve3D[] singular() throws JgclIndefiniteSolution {
	Vector singularVec = new Vector();
	JgclPointOnCurve3D[] singular = basisCurve.singular();
	JgclParameterDomain domain = parameterDomain();

	for (int i = 0; i < singular.length; i++) {
	    double param = toOwnParameter(singular[i].parameter());
	    param = forceComputedParameter(param);

	    if (Double.isNaN(param) == true)
		continue;

	    try {
		singularVec.addElement(new JgclPointOnCurve3D(this, param, doCheckDebug));
	    }
	    catch(JgclInvalidArgumentValue e) {
		throw new JgclFatal();
	    }

	}
	JgclPointOnCurve3D[] thisSingular =
	    new JgclPointOnCurve3D[singularVec.size()];
	singularVec.copyInto(thisSingular);
	return thisSingular;
    }

    /**
     * ̋Ȑ̕ϋȓ_ԂB
     * <p>
     * ϋȓ_݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @return	ϋȓ_̔z
     * @exception	JgclIndefiniteSolution	sł
     */
    public JgclPointOnCurve3D[] inflexion() throws JgclIndefiniteSolution {
	Vector inflexionVec = new Vector();
	JgclPointOnCurve3D[] inflexion = basisCurve.inflexion();
	JgclParameterDomain domain = parameterDomain();

	for (int i = 0; i < inflexion.length; i++) {
	    double param = toOwnParameter(inflexion[i].parameter());
	    param = forceComputedParameter(param);

	    if (Double.isNaN(param) == true)
		continue;

	    try {
		inflexionVec.addElement
		    (new JgclPointOnCurve3D(this, param, doCheckDebug));
	    }
	    catch(JgclInvalidArgumentValue e) {
		throw new JgclFatal();
	    }

	}
	JgclPointOnCurve3D[] thisInflexion =
	    new JgclPointOnCurve3D[inflexionVec.size()];
	inflexionVec.copyInto(thisInflexion);
	return thisInflexion;
    }

    /**
     * ^ꂽ_炱̋Ȑւ̓e_߂B
     * <p>
     * e_݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param point	e̓_
     * @return	e_
     * @exception JgclIndefiniteSolution	sł
     */
    public JgclPointOnCurve3D[] projectFrom(JgclPoint3D point)
	throws JgclIndefiniteSolution
    {
	Vector projvec = new Vector();
	JgclPointOnCurve3D[] proj = basisCurve.projectFrom(point);
	JgclParameterDomain domain = parameterDomain();

	for (int i = 0; i < proj.length; i++) {
 	    JgclPointOnCurve3D proj2;
 	    double param = toOwnParameter(proj[i].parameter());
	    param = forceComputedParameter(param);

	    if (Double.isNaN(param) == true)
		continue;

	    try {
 		proj2 = new JgclPointOnCurve3D(this, param, doCheckDebug);
	    }
	    catch(JgclInvalidArgumentValue e) {
		throw new JgclFatal();
	    }

	    projvec.addElement(proj2);
	}
 	JgclPointOnCurve3D[] prj = new JgclPointOnCurve3D[projvec.size()];
	projvec.copyInto(prj);
	return prj;
    }

    /**
     * ̋Ȑ̎w̋ԂA^ꂽ덷Œߎ|CԂB
     * <p>
     * ʂƂĕԂ|C\_
     * ̋Ȑx[XȐƂ JgclPointOnCurve3D 
     * 邱Ƃ҂łB
     * </p>
     * <p>
     * section ̒lÃxWGȐ̒`OĂꍇɂ
     * JgclParameterOutOfRange ̗O𔭐B
     * </p>
     *
     * @param section	ߎp[^
     * @param tolerance	̋e덷
     * @return		̋Ȑ̎w̋Ԃ𒼐ߎ|C
     * @see	JgclParameterOutOfRange
     */
    public JgclPolyline3D toPolyline(JgclParameterSection pint,
				     JgclToleranceForDistance tol) 
    {
	JgclPolyline3D pl = basisCurve.toPolyline(toBasisParameter(pint), tol);
	JgclPoint3D[] pnts = new JgclPoint3D[pl.nPoints()];

	for (int i = 0; i < pnts.length; i++) {
            JgclPointOnCurve3D p = (JgclPointOnCurve3D)pl.pointAt(i);
            pnts[i] = new JgclPointOnCurve3D(this, toOwnParameter(p.parameter()), doCheckDebug);
	}

	return new JgclPolyline3D(pnts);
    }

    /**
     * ̋Ȑ̎w̋ԂɍČL Bspline ȐԂB
     * <p>
     * pint ̒lÂaXvCȐ̒`OĂꍇɂ
     * JgclParameterOutOfRange ̗O𔭐B
     * </p>
     * 
     * @param pint	L Bspline ȐōČp[^
     * @return		̋Ȑ̎w̋ԂČL Bspline Ȑ
     * @see	JgclParameterOutOfRange
     */
    public JgclBsplineCurve3D toBsplineCurve(JgclParameterSection pint) {
	return basisCurve.toBsplineCurve(toBasisParameter(pint));
    }

    /**
     * ̋ȐƑ̋Ȑ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * <p>
     * []
     * ̋Ȑ̕ȐƑ̋Ȑ̌_߂ɁA
     * ̓ł̋Ȑ̃g~OԂ̓Ɏ܂Ă
     * u_vƂĂB
     * </p>
     * 
     * @param mate	̋Ȑ
     * @param doExchange	_ pointOnGeometry1/2 邩ǂ
     * @return	_̔z
     */
    private JgclIntersectionPoint3D[] doIntersect(JgclParametricCurve3D mate,	
						  boolean doExchange) {
	Vector intsvec = new Vector();

	JgclIntersectionPoint3D[] ints;
	try {
	    ints = basisCurve.intersect(mate);
	} catch (JgclIndefiniteSolution e) {
	    ints = new JgclIntersectionPoint3D[0];	// ??
	}
	JgclParameterDomain domain = parameterDomain();

	for (int i = 0; i < ints.length; i++) {
	    JgclPointOnCurve3D pnt1 =
		(JgclPointOnCurve3D)ints[i].pointOnGeometry1();
	    double param = toOwnParameter(pnt1.parameter());
	    param = forceComputedParameter(param);

	    if (Double.isNaN(param) == true)
		continue;

	    JgclPointOnCurve3D pnts = new JgclPointOnCurve3D(this, param, doCheckDebug);
	    JgclIntersectionPoint3D ints2 = 
		new JgclIntersectionPoint3D(pnts, ints[i].pointOnCurve2(), doCheckDebug);

	    intsvec.addElement(ints2);
	}

	JgclIntersectionPoint3D[] xints =
	    new JgclIntersectionPoint3D[intsvec.size()];
	intsvec.copyInto(xints);
	if (doExchange)
	    for (int i = 0; i < xints.length; i++)
		xints[i] = xints[i].exchange();

	return xints;
    }

    /**
     * ̋ȐƑ̋Ȑ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȑ
     * @return	_̔z
     */
    public JgclIntersectionPoint3D[] intersect(JgclParametricCurve3D mate) {
	return doIntersect(mate, false);
    }

    /**
     * ̋ȐƑ̋Ȑ () ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȑ ()
     * @param doExchange	_ pointOnGeometry1/2 邩ǂ
     * @return	_̔z
     * @see	#doIntersect(JgclParametricCurve3D, boolean)
     */
    JgclIntersectionPoint3D[] intersect(JgclLine3D mate, boolean doExchange) {
	return doIntersect(mate, doExchange);
    }

    /**
     * ̋ȐƑ̋Ȑ (~) ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȑ (~)
     * @param doExchange	_ pointOnGeometry1/2 邩ǂ
     * @return	_̔z
     * @see	#doIntersect(JgclParametricCurve3D, boolean)
     */
    JgclIntersectionPoint3D[] intersect(JgclCircle3D mate, boolean doExchange) {
	return doIntersect(mate, doExchange);
    }

    /**
     * ̋ȐƑ̋Ȑ (ȉ~) ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȑ (ȉ~)
     * @param doExchange	_ pointOnGeometry1/2 邩ǂ
     * @return	_̔z
     * @see	#doIntersect(JgclParametricCurve3D, boolean)
     */
    JgclIntersectionPoint3D[] intersect(JgclEllipse3D mate, boolean doExchange) {
	return doIntersect(mate, doExchange);
    }

    /**
     * ̋ȐƑ̋Ȑ () ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȑ ()
     * @param doExchange	_ pointOnGeometry1/2 邩ǂ
     * @return	_̔z
     * @see	#doIntersect(JgclParametricCurve3D, boolean)
     */
    JgclIntersectionPoint3D[] intersect(JgclParabola3D mate, boolean doExchange) {
	return doIntersect(mate, doExchange);
    }

    /**
     * ̋ȐƑ̋Ȑ (oȐ) ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȑ (oȐ)
     * @param doExchange	_ pointOnGeometry1/2 邩ǂ
     * @return	_̔z
     * @see	#doIntersect(JgclParametricCurve3D, boolean)
     */
    JgclIntersectionPoint3D[] intersect(JgclHyperbola3D mate, boolean doExchange) {
	return doIntersect(mate, doExchange);
    }

    /**
     * ̋ȐƑ̋Ȑ (|C) ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȑ (|C)
     * @param doExchange	_ pointOnGeometry1/2 邩ǂ
     * @return	_̔z
     * @see	#doIntersect(JgclParametricCurve3D, boolean)
     */
    JgclIntersectionPoint3D[] intersect(JgclPolyline3D mate, boolean doExchange) {
	return doIntersect(mate, doExchange);
    }

    /**
     * ̋ȐƑ̋Ȑ (xWGȐ) ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȑ (xWGȐ)
     * @param doExchange	_ pointOnGeometry1/2 邩ǂ
     * @return	_̔z
     * @see	#doIntersect(JgclParametricCurve3D, boolean)
     */
    JgclIntersectionPoint3D[] intersect(JgclPureBezierCurve3D mate, boolean doExchange) {
	return doIntersect(mate, doExchange);
    }

    /**
     * ̋ȐƑ̋Ȑ (aXvCȐ) ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȑ (aXvCȐ)
     * @param doExchange	_ pointOnGeometry1/2 邩ǂ
     * @return	_̔z
     * @see	#doIntersect(JgclParametricCurve3D, boolean)
     */
    JgclIntersectionPoint3D[] intersect(JgclBsplineCurve3D mate, boolean doExchange) {
	return doIntersect(mate, doExchange);
    }

    /**
     * ̋ȐƑ̋Ȑ (gȐ) ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȑ (gȐ)
     * @param doExchange	_ pointOnGeometry1/2 邩ǂ
     * @return	_̔z
     * @see	#doIntersect(JgclParametricCurve3D, boolean)
     */
    JgclIntersectionPoint3D[] intersect(JgclTrimmedCurve3D mate, boolean doExchange) {
	return doIntersect(mate, doExchange);
    }

    /**
     * ̋ȐƑ̋Ȑ (ȐZOg) ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȑ (ȐZOg)
     * @param doExchange	_ pointOnGeometry1/2 邩ǂ
     * @return	_̔z
     * @see	#doIntersect(JgclParametricCurve3D, boolean)
     */
    JgclIntersectionPoint3D[] intersect(JgclCompositeCurveSegment3D mate, boolean doExchange) {
	return doIntersect(mate, doExchange);
    }

    /**
     * ̋ȐƑ̋Ȑ (Ȑ) ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȑ (Ȑ)
     * @param doExchange	_ pointOnGeometry1/2 邩ǂ
     * @return	_̔z
     * @see	#doIntersect(JgclParametricCurve3D, boolean)
     */
    JgclIntersectionPoint3D[] intersect(JgclCompositeCurve3D mate, boolean doExchange) {
	return doIntersect(mate, doExchange);
    }

    /**
     * ̋ȐƑ̋Ȗʂ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     *
     * @param mate	̋Ȗ
     * @param doExchange	_ pointOnGeometry1/2 邩ǂ
     * @return		_̔z
     */
    JgclIntersectionPoint3D[] doIntersect(JgclParametricSurface3D mate,
					  boolean doExchange)
    {
	JgclIntersectionPoint3D[] intp;
	try {
	    intp = basisCurve().intersect(mate);
	}
	catch (JgclIndefiniteSolution e) {
	    intp = new JgclIntersectionPoint3D[0]; // ??
	}
	JgclCurveSurfaceInterferenceList intfList =
	    new JgclCurveSurfaceInterferenceList(this, mate);

	for (int i = 0; i < intp.length; i++) {
	    JgclPointOnCurve3D crvPnt =
		(JgclPointOnCurve3D)intp[i].pointOnGeometry1();
	    JgclPointOnSurface3D srfPnt =
		(JgclPointOnSurface3D)intp[i].pointOnGeometry2();
	    double crvParam = toOwnParameter(crvPnt.parameter());

	    // check boundary
	    crvParam = forceComputedParameter(crvParam);

	    if (Double.isNaN(crvParam) == true)
		continue;

	    // add solution to List
	    intfList.addAsIntersection(intp[i].coordinates(), crvParam,
				       srfPnt.uParameter(), srfPnt.vParameter());
	}
	return intfList.toJgclIntersectionPoint3DArray(doExchange);
    }

    /**
     * ̋ȐƑ̋Ȗʂ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȗ
     * @return		_̔z
     */
    public JgclIntersectionPoint3D[] intersect(JgclParametricSurface3D mate) {
	return doIntersect(mate, false);
    }

    /**
     * ̋ȐƑ̋Ȗʂ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȗ
     * @param doExchange	_ pointOnGeometry1/2 邩ǂ
     * @return		_̔z
     */
    JgclIntersectionPoint3D[] intersect(JgclParametricSurface3D mate,
					boolean doExchange) {
	return doIntersect(mate, doExchange);
    }

    /**
     * ̋ȐƑ̋Ȗ (͋Ȗ) ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȗ (͋Ȗ)
     * @param doExchange	_ pointOnGeometry1/2 邩ǂ
     * @return		_̔z
     */
    JgclIntersectionPoint3D[] intersect(JgclElementarySurface3D mate,
					boolean doExchange) {
	return doIntersect(mate, doExchange);
    }

    /**
     * ̋ȐƑ̋Ȗ (xWGȖ) ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȗ (xWGȖ)
     * @param doExchange	_ pointOnGeometry1/2 邩ǂ
     * @return		_̔z
     */
    JgclIntersectionPoint3D[] intersect(JgclPureBezierSurface3D mate,
					boolean doExchange) {
	return doIntersect(mate, doExchange);
    }

    /**
     * ̋ȐƑ̋Ȗ (aXvCȖ) ̌_߂B
     * <p>
     * _݂ȂƂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȗ (aXvCȖ)
     * @param doExchange	_ pointOnGeometry1/2 邩ǂ
     * @return		_̔z
     */
    JgclIntersectionPoint3D[] intersect(JgclBsplineSurface3D mate,
					boolean doExchange) {
	return doIntersect(mate, doExchange);
    }

    /**
     * Ȑɑ΂p[^l
     * gȐɑ΂p[^lւ̕ϊ\NXB
     * @see	#interfere(JgclBoundedCurve3D, boolean)
     */
    class ToTrimConversion extends JgclParameterConversion3D {
	/**
	 * gȐB
	 */
	JgclTrimmedCurve3D curve;

	/**
	 * gȐ^ăIuWFNg\zB
	 *
	 * @param curve	gȐ
	 */
	ToTrimConversion(JgclTrimmedCurve3D curve) {
	    this.curve = curve;
	}

	/**
	 * Ȑɑ΂p[^lgȐɑ΂p[^l֕ϊB
	 * 
	 * @param param	Ȑɑ΂p[^l
	 * @return	gȐɑ΂p[^l
	 */
	double convParameter(double param) {
	    return curve.toOwnParameter(param);
	}

	/**
	 * Ȑɑ΂p[^lϊΏۂłgȐԂB
	 * 
	 * @param param Ȑɑ΂p[^l
	 * @return	gȐ
	 */
	JgclParametricCurve3D convCurve(double param) {
	    return curve;
	}
    }

    /**
     * aXvCȐɑ΂p[^l
     * gȐɑ΂p[^lւ̕ϊ\NXB
     * @see	#interfere(JgclBoundedCurve3D, boolean)
     */
    class BsplineConversion extends JgclParameterConversion3D {
	/**
	 * gȐB
	 */
	JgclTrimmedCurve3D curve;

	/**
	 * aXvCȐB
	 */
	JgclBoundedCurve3D bcurve;

	/**
	 * gȐƂaXvCȐ^ăIuWFNg\zB
	 *
	 * @param curve	gȐ
	 * @param bcurve	aXvCȐ
	 */
	BsplineConversion(JgclTrimmedCurve3D curve,
			  JgclBoundedCurve3D bcurve) {
	    this.curve = curve;
	    this.bcurve = bcurve;
	}

	/**
	 * aXvCȐɑ΂p[^lgȐɑ΂p[^l֕ϊB
	 * <p>
	 * ^ꂽp[^lɑΉaXvCȐ̓_
	 * gȐ̕ȐɏĂȂꍇɂ
	 * JgclInvalidArgumentValue ̗O𔭐B
	 * </p>
	 * 
	 * @param param	aXvCȐɑ΂p[^l
	 * @return	gȐɑ΂p[^l
	 * @see	JgclParametricCurve3D#pointToParameter(JgclPoint3D)
	 * @see	JgclInvalidArgumentValue
	 */
	double convParameter(double param) {
	    JgclPointOnCurve3D pnt = new JgclPointOnCurve3D(bcurve, param, doCheckDebug);
	    double bparam = curve.basisCurve().pointToParameter(pnt);
	    return curve.toOwnParameter(bparam);
	}

	/**
	 * aXvCȐɑ΂p[^lϊΏۂłgȐԂB
	 * 
	 * @param param	aXvCȐɑ΂p[^l
	 * @return	gȐ
	 */
	JgclParametricCurve3D convCurve(double param) {
	    return curve;
	}
    }

    /**
     * ̗LȐƑ̗LȐ̊߂B
     * <p>
     * ݂Ȃꍇɂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̋Ȑ
     * @return		Ȑ̊̔z
     */
    public JgclCurveCurveInterference3D[] interfere(JgclBoundedCurve3D mate) {
	return this.interfere(mate, false);
    }

    /**
     * ̗LȐƑ̗LȐ̊߂B
     * <p>
     * ݂Ȃꍇɂ͒ 0 ̔zԂB
     * </p>
     * <p>
     * []
     * <br>
     * ̋Ȑ̕ȐƑ̗LȐ̊߂ɁA
     * ̓̂̋Ȑ̃g~OԂ̓Ɏ܂Ă镔
     * uvƂĂB
     * ȂA̋Ȑ̕ȐLłȂꍇɂ́A
     * Ȑ̃g~OԂLaXvCȐɕϊA
     * ̗LaXvCȐƑ̗LȐ̊x[X̊ƂB
     * </p>
     * 
     * @param mate	̋Ȑ
     * @param doExchange	 this  mate ̈ʒu邩ǂ
     * @return		Ȑ̊̔z
     * @see	JgclTrimmedCurve3D.ToTrimConversion
     * @see	JgclTrimmedCurve3D.BsplineConversion
     */
    JgclCurveCurveInterference3D[] interfere(JgclBoundedCurve3D mate,
					     boolean doExchange) {
	JgclCurveCurveInterferenceList intfList
	    = new JgclCurveCurveInterferenceList(this, mate);
	JgclParameterDomain domain = parameterDomain();
	JgclBoundedCurve3D bcurve;
	JgclParameterConversion3D conv;
	JgclParameterSection sec =
	    new JgclParameterSection(tParam1, tParam2 - tParam1);

	if (basisCurve instanceof JgclBoundedCurve3D) {
	    bcurve = (JgclBoundedCurve3D)basisCurve;
	    conv = new ToTrimConversion(this);
	}
	else {
	    bcurve = basisCurve.toBsplineCurve(sec);
	    conv = new BsplineConversion(this, bcurve);
	}

	JgclCurveCurveInterference3D[] intf;
	if (!doExchange) {
	    intf = bcurve.interfere(mate);
	} else {
	    intf = mate.interfere(bcurve);
	}

	Vector vec = new Vector();

	for (int i = 0; i < intf.length; i++) {
	    JgclCurveCurveInterference3D trimintf;
	    if (!doExchange) {
		trimintf = intf[i].trim1(sec, conv);
	    } else {
		trimintf = intf[i].trim2(sec, conv);
	    }
	    if (trimintf != null)
		vec.addElement(trimintf);
	}
	JgclCurveCurveInterference3D[] interf =
	    new JgclCurveCurveInterference3D[vec.size()];
	vec.copyInto(interf);
	return interf;
    }

    /**
     * ̗LȐƑ̗LȐ () ̊߂B
     * <p>
     * ݂Ȃꍇɂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̗LȐ ()
     * @param doExchange	 this  mate ̈ʒu邩ǂ
     * @return		
     * @see	#interfere(JgclBoundedCurve3D, boolean)
     */
    JgclCurveCurveInterference3D[] interfere(JgclBoundedLine3D mate,
					     boolean doExchange)
    {
	return this.interfere((JgclBoundedCurve3D)mate, doExchange);
    }

    /**
     * ̗LȐƑ̗LȐ (|C) ̊߂B
     * <p>
     * ݂Ȃꍇɂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̗LȐ (|C)
     * @param doExchange	 this  mate ̈ʒu邩ǂ
     * @return		
     * @see	#interfere(JgclBoundedCurve3D, boolean)
     */
    JgclCurveCurveInterference3D[] interfere(JgclPolyline3D mate,
					     boolean doExchange)
    {
	return this.interfere((JgclBoundedCurve3D)mate, doExchange);
    }

    /**
     * ̗LȐƑ̗LȐ (xWGȐ) ̊߂B
     * <p>
     * ݂Ȃꍇɂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̗LȐ (xWGȐ)
     * @param doExchange	 this  mate ̈ʒu邩ǂ
     * @return		
     * @see	#interfere(JgclBoundedCurve3D, boolean)
     */
    JgclCurveCurveInterference3D[] interfere(JgclPureBezierCurve3D mate,
					     boolean doExchange)
    {
	return this.interfere((JgclBoundedCurve3D)mate, doExchange);
    }

    /**
     * ̗LȐƑ̗LȐ (aXvCȐ) ̊߂B
     * <p>
     * ݂Ȃꍇɂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̗LȐ (aXvCȐ)
     * @param doExchange	 this  mate ̈ʒu邩ǂ
     * @return		
     * @see	#interfere(JgclBoundedCurve3D, boolean)
     */
    JgclCurveCurveInterference3D[] interfere(JgclBsplineCurve3D mate,
					     boolean doExchange)
    {
	return this.interfere((JgclBoundedCurve3D)mate, doExchange);
    }

    /**
     * ̗LȐƑ̗LȐ (gȐ) ̊߂B
     * <p>
     * ݂Ȃꍇɂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̗LȐ (gȐ)
     * @param doExchange	 this  mate ̈ʒu邩ǂ
     * @return		
     * @see	#interfere(JgclBoundedCurve3D, boolean)
     */
    JgclCurveCurveInterference3D[] interfere(JgclTrimmedCurve3D mate,
					     boolean doExchange) {
	return this.interfere((JgclBoundedCurve3D)mate, doExchange);
    }

    /**
     * ̗LȐƑ̗LȐ (ȐZOg) ̊߂B
     * <p>
     * ݂Ȃꍇɂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̗LȐ (ȐZOg)
     * @param doExchange	 this  mate ̈ʒu邩ǂ
     * @return		
     * @see	#interfere(JgclBoundedCurve3D, boolean)
     */
    JgclCurveCurveInterference3D[] interfere(JgclCompositeCurveSegment3D mate,
					     boolean doExchange) {
	return mate.interfere(this, !doExchange);
    }

    /**
     * ̗LȐƑ̗LȐ (Ȑ) ̊߂B
     * <p>
     * ݂Ȃꍇɂ͒ 0 ̔zԂB
     * </p>
     * 
     * @param mate	̗LȐ (Ȑ)
     * @param doExchange	 this  mate ̈ʒu邩ǂ
     * @return		
     * @see	#interfere(JgclBoundedCurve3D, boolean)
     */
    JgclCurveCurveInterference3D[] interfere(JgclCompositeCurve3D mate,
					     boolean doExchange) {
	return mate.interfere(this, !doExchange);
    }

    /**
     * ̋ȐA^ꂽxNgɏ]ĕsړȐԂB
     *
     * @param moveVec	sړ̕Ɨʂ\xNg
     * @return		sړ̋Ȑ
     */
    public JgclParametricCurve3D parallelTranslate(JgclVector3D moveVec) {
	JgclParametricCurve3D newBasis = basisCurve.parallelTranslate(moveVec);
	JgclPoint3D newTPnt1, newTPnt2;
	if (tPnt1 != null)
	    newTPnt1 = tPnt1.add(moveVec);
	else
	    newTPnt1 = null;
	if (tPnt2 != null)
	    newTPnt2 = tPnt2.add(moveVec);
	else
	    newTPnt2 = null;
	return new JgclTrimmedCurve3D(newBasis, newTPnt1, newTPnt2, tParam1, tParam2, masterRepresentation1,
				      masterRepresentation2, senseAgreement);
    }

    /**
     * ̋Ȑ̃p[^`ԂB
     * <p>
     * [0, |tParam2 - tParam1|] ԂB
     * </p>
     * 
     * @return	LŔIȃp[^`
     */
    JgclParameterDomain getParameterDomain() {
	try {
	    return new JgclParameterDomain(false, 0,
					   Math.abs(tParam2 - tParam1));
	}
	catch (JgclInvalidArgumentValue e) {
	    // should never be occurred
	    throw new JgclFatal();
	}
    }

    /**
     * ̊􉽗vfR`󂩔ۂԂB
     *
     * @return	ȐR`ł trueAłȂ false
     */
    public boolean isFreeform() {
	return this.basisCurve.isFreeform();
    }

    /**
     * ̗LȐ̊Jn_ԂB
     * <p>
     * masterRepresentation1  PARAMETER Ȃ΁AȐ tParam1 ŕ]lԂB
     * masterRepresentation1  POINT Ȃ΁AtPnt1 ԂB
     * </p>
     *
     * @return	Jn_
     */
    public JgclPoint3D startPoint() {
	JgclPoint3D pnt1;

	try {
	    if (this.tPnt1 == null ||
		masterRepresentation1 == JgclTrimmingPreference.PARAMETER)
		pnt1 = basisCurve.coordinates(tParam1);
	    else
		pnt1 = this.tPnt1;
	}
	catch (JgclParameterOutOfRange e) {
	    // should never be occurred
	    throw new JgclFatal();
	}
	if (this.tPnt1 == null)
	    this.tPnt1 = pnt1;
	return pnt1;
    }

    /**
     * ̗LȐ̏I_ԂB
     * <p>
     * masterRepresentation2  PARAMETER Ȃ΁AȐ tParam2 ŕ]lԂB
     * masterRepresentation2  POINT Ȃ΁AtPnt2 ԂB
     * </p>
     *
     * @return	I_
     */
    public JgclPoint3D endPoint() {
	JgclPoint3D pnt2;

	try {
	    if (this.tPnt2 == null ||
		masterRepresentation2 == JgclTrimmingPreference.PARAMETER)
		pnt2 = basisCurve.coordinates(tParam2);
	    else
		pnt2 = this.tPnt2;
	}
	catch (JgclParameterOutOfRange e) {
	    // should never be occurred
	    throw new JgclFatal();
	}
	if (this.tPnt2 == null)
	    this.tPnt2 = pnt2;
	return pnt2;
    }

    /**
     * vfʂԂB
     *
     * @return	{@link JgclParametricCurve3D#TRIMMED_CURVE_3D JgclParametricCurve3D.TRIMMED_CURVE_3D}
     */
    int type() {
	return TRIMMED_CURVE_3D;
    }

    /**
     * ̋ȐA^ꂽǏWn Z ̎ɁA
     * ^ꂽpx]ȐԂB
     *
     * @param trns	ǏWn瓾ꂽWϊZq
     * @param rCos	cos(]px)
     * @param rSin	sin(]px)
     * @return		]̋Ȑ
     */
    JgclParametricCurve3D rotateZ(JgclCartesianTransformationOperator3D trns,
				  double rCos, double rSin) {
	JgclParametricCurve3D r_basis = basisCurve().rotateZ(trns, rCos, rSin);
	JgclPoint3D r_tPnt1, r_tPnt2;

	if ((r_tPnt1 = tPnt1()) != null)
	    r_tPnt1 = r_tPnt1.rotateZ(trns, rCos, rSin);
	if ((r_tPnt2 = tPnt2()) != null)
	    r_tPnt2 = r_tPnt2.rotateZ(trns, rCos, rSin);

	return new JgclTrimmedCurve3D(r_basis, r_tPnt1, r_tPnt2, tParam1(), tParam2(),
				      masterRepresentation1(), masterRepresentation2(),
				      senseAgreement());
    }

    /**
     * ̋Ȑ̓_ŁA^ꂽɂȂ_ԂB
     *
     * @param line	
     * @return		^ꂽɂȂ_
     */
    JgclPoint3D getPointNotOnLine(JgclLine3D line) {
	JgclParameterSection pint = parameterDomain().section();
	JgclBsplineCurve3D b_spline = toBsplineCurve(pint);

	return b_spline.getPointNotOnLine(line);
    }

    /**
     * ̋ȐA^ꂽ􉽓IϊZqŕϊB
     * <p>
     * transformedGeometries ́A
     * ϊO̊􉽗vfL[ƂA
     * ϊ̊􉽗vflƂnbVe[ułB
     * </p>
     * <p>
     * this  transformedGeometries ɃL[Ƃđ݂Ȃꍇɂ́A
     * this  transformationOperator ŕϊ̂ԂB
     * ̍ۂɃ\bhł this L[A
     * ϊʂlƂ transformedGeometries ɒǉB
     * </p>
     * <p>
     * this  transformedGeometries ɊɃL[Ƃđ݂ꍇɂ́A
     * ۂ̕ϊ͍sȂ킸ÃL[ɑΉlԂB
     * ͍̏ċAIɍsȂB
     * </p>
     * <p>
     * transformedGeometries  null ł\ȂB
     * transformedGeometries  null ̏ꍇɂ́A
     *  this  transformationOperator ŕϊ̂ԂB
     * </p>
     *
     * @param reverseTransform		tϊ̂ł trueAłȂ false
     * @param transformationOperator	􉽓IϊZq
     * @param transformedGeometries	ɓl̕ϊ{􉽗vf܂ރnbVe[u
     * @return	ϊ̊􉽗vf
     */
    protected synchronized JgclParametricCurve3D
    doTransformBy(boolean reverseTransform,
		  JgclCartesianTransformationOperator3D transformationOperator,
		  java.util.Hashtable transformedGeometries)
    {
	JgclParametricCurve3D tBasisCurve =
	    this.basisCurve().transformBy(reverseTransform,
					  transformationOperator,
					  transformedGeometries);
	JgclPoint3D tTPnt1 = null;
	JgclPoint3D tTPnt2 = null;
	if (this.masterRepresentation1() == JgclTrimmingPreference.POINT)
	    tTPnt1 = this.tPnt1().transformBy(reverseTransform,
					      transformationOperator,
					      transformedGeometries);
	if (this.masterRepresentation2() == JgclTrimmingPreference.POINT)
	    tTPnt2 = this.tPnt2().transformBy(reverseTransform,
					      transformationOperator,
					      transformedGeometries);

	return new JgclTrimmedCurve3D(tBasisCurve,
				      tTPnt1, tTPnt2,
				      this.tParam1(), this.tParam2(),
				      this.masterRepresentation1(),
				      this.masterRepresentation2(),
				      this.senseAgreement());
    }

    /**
     * ̋Ȑ|C̕܂ނۂԂB
     *
     * @return	̋Ȑ|Cł邩A
     *		܂͎g\镔iƂă|C܂ނȂ trueA
     *		łȂ false
     */
    protected boolean hasPolyline() {
	return basisCurve.hasPolyline();
    }

    /**
     * ̋Ȑ|C̕łłĂ邩ۂԂB
     *
     * @return	̋Ȑ|Cł邩A
     *		܂͎g\镔iƂă|C܂ނȂ trueA
     *		łȂ false
     */
    protected boolean isComposedOfOnlyPolylines() {
	return basisCurve.isComposedOfOnlyPolylines();
    }

    /**
     * o̓Xg[Ɍ`o͂B
     *
     * @param writer    PrintWriter
     * @param indent	Cfg̐[
     * @see		JgclGeometry
     */
    protected void output(PrintWriter writer, int indent) {
        String indent_tab = makeIndent(indent);

        writer.println(indent_tab + getClassName());
        writer.println(indent_tab + "\tbasisCurve");
        basisCurve.output(writer, indent + 2);
	if (tPnt1 != null) {
	    writer.println(indent_tab + "\ttPnt1");
	    tPnt1.output(writer, indent + 2);
	}
	if (tPnt2 != null) {
	    writer.println(indent_tab + "\ttPnt2");
	    tPnt2.output(writer, indent + 2);
	}
        writer.println(indent_tab + "\ttParam1\t" + tParam1);
        writer.println(indent_tab + "\ttParam2\t" + tParam2);
        writer.println(indent_tab + "\tmasterRepresentation1\t"
		+ JgclTrimmingPreference.toString(masterRepresentation1));
        writer.println(indent_tab + "\tmasterRepresentation2\t"
		+ JgclTrimmingPreference.toString(masterRepresentation2));
        writer.println(indent_tab + "\tsenseAgreement\t" + senseAgreement);
        writer.println(indent_tab + "End");
    }
}
